/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
#ifndef __dj_include_time_h_
#define __dj_include_time_h_

#include <posix/types.h>

#ifdef __cplusplus
extern "C" {
#endif

#define CLOCKS_PER_SEC	1000000

#ifdef __KERNEL__
struct tm {
  int 	tm_sec;
  int 	tm_min;
  int 	tm_hour;
  int 	tm_mday;
  int 	tm_mon;
  int 	tm_year;
  int 	tm_wday;
  int 	tm_yday;
  int 	tm_isdst;
  char* tm_zone;
  int 	tm_gmtoff;
};

/* A time value that is accurate to the nearest
   microsecond but also has a range of years.  */

#endif

struct kernel_timeval
{
  time_t tv_sec;		/* Seconds.  */
  time_t tv_usec;		/* Microseconds.  */
};


/*#define tm_zone __tm_zone*/
/*#define tm_gmtoff __tm_gmtoff*/

#if 0
char *		asctime(const struct tm *_tptr);
clock_t		clock(void);
char *		ctime(const time_t *_cal);
double		difftime(time_t _t1, time_t _t0);
struct tm *	gmtime(const time_t *_tod);
struct tm *	localtime(const time_t *_tod);
time_t		mktime(struct tm *_tptr);
size_t		strftime(char *_s, size_t _n, const char *_format, const struct tm *_tptr);
time_t		time(time_t *_tod);

#define CLK_TCK	CLOCKS_PER_SEC

extern char *tzname[2];

void	tzset(void);


struct timeval {
  time_t tv_sec;
  long tv_usec;
};

struct timezone {
  int tz_minuteswest;
  int tz_dsttime;
};

struct timespec {
  time_t tv_sec;	/* seconds */
  long	 tv_nsec;	/* nanoseconds */
};

typedef long long uclock_t;
#define UCLOCKS_PER_SEC 1193180

int		gettimeofday(struct timeval *_tp, struct timezone *_tzp);
unsigned long	rawclock(void);


int select(int _nfds, fd_set *_readfds, fd_set *_writefds, fd_set *_exceptfds, struct timeval *_timeout);


int		settimeofday( const struct timeval *_tp, ...);
uclock_t	uclock(void);

#endif



#ifdef __cplusplus
}
#endif

#endif /* !__dj_include_time_h_ */
