#ifndef __ATHEOS_WAIT_H_
#define __ATHEOS_WAIT_H_

#include <posix/resource.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <posix/types.h>

#define WEXITSTATUS(stat_val)	( (stat_val>>8) & 0x000ff )
#define WIFEXITED(stat_val)		( ((stat_val) & 0xff) == 0)
#define WIFSIGNALED(stat_val)	( ((stat_val) & 0xff) > 0 && (((stat_val) >> 8) & 0xff) == 0 )
#define	_WSTOPPED 0x7f
#define WIFSTOPPED(stat_val)	( (((stat_val) & 0xff) == _WSTOPPED) && (((stat_val)>>8) & 0xff) != 0 )
#define WSTOPSIG(stat_val)		( (stat_val>>8) & 0xff )
#define WTERMSIG(stat_val)	  ( (stat_val) & 0x7f )

#define WNOHANG		1
#define WUNTRACED	2

pid_t wait(int *stat_loc);
pid_t waitpid(pid_t pid, int *stat_loc, int options);

pid_t wait4( pid_t hPid, int* pnStatLoc, int nOptions, struct rusage* psRUsage );


#ifdef __cplusplus
}
#endif

#endif /* __ATHEOS_WAIT_H_ */
